//-----------------------------------------------------------
//    SynthEG
//-----------------------------------------------------------
#ifndef __EG_H__
#define __EG_H__
enum EGState{ATTACK, DECAY, SUSTAIN, RELEASE, NON};
extern const unsigned int inv_exp_table_size;
extern const float inv_exp_table[];
//-----------------------------------------------------------
//    class SynthEG
//-----------------------------------------------------------
class SynthEG
{
public:
	SynthEG();
	virtual ~SynthEG();
	void SetEGState(const EGState egs1);
	EGState GetEGState() const;
	float GetValue();
	void ResetPhase();
	void SetAttackCount(const int acount);
	void SetDecayCount(const int dcount);
	void SetReleaseCount(const int rcount);
	void SetSustainLevel(const float slevel);
private:
	EGState state1;
	int phase;
	int attack_count;
	int decay_count;
	int release_count;
	float delta_phase_decay;
	float delta_phase_release;
	float sustain_level;
	float release_level;
	float attack_rate;
	volatile float pre_val;
};
#endif

