//-----------------------------------------------------------
//    mixer.cpp
//-----------------------------------------------------------
#include "mixer.h"
//-----------------------------------------------------------
//    
//-----------------------------------------------------------
Mixer::Mixer(int id1)
	: SignalProcessBase(id1)
{
	SetSignalProcessType(MIXER);
	SetUpLimit(-1);
}

//-----------------------------------------------------------
//    
//-----------------------------------------------------------
Mixer::~Mixer()
{
}

//-----------------------------------------------------------
//    
//-----------------------------------------------------------
void Mixer::Work()
{
	unsigned int isz = GetUpStream().size();
	unsigned int bsz = GetSizeBuffer();
	float dtmp = 1.0 / (float)isz;
	float btmp1[bsz], btmp2[bsz];
	
	for(int i1 = 0; i1 < bsz; i1++){
		btmp1[i1] = 0.0;
	}
	for(int i1 = 0; i1 < isz; i1++){
		GetUpStream(i1)->CopyBuffer(btmp2);
		for(int i2 = 0; i2 < bsz; i2++){
			btmp1[i2] += btmp2[i2];
		}
	}
	for(int i1 = 0; i1 < bsz; i1++){
		btmp1[i1] *= dtmp;
	}
	WriteBuffer(btmp1);
	GiveTask();
	AccomplishTask();
}
