//-----------------------------------------------------------
//    ToPortAudio
//-----------------------------------------------------------
#ifndef __TO_PORTAUDIO_H__
#define __TO_PORTAUDIO_H__
#include "signal_process_base.h"
#include <vector>
#include <portaudio.h>
enum PaState{STATE_A, STATE_B};
//-----------------------------------------------------------
//    class ToPortAudio
//-----------------------------------------------------------
class ToPortAudio : public SignalProcessBase
{
public:
	ToPortAudio(int id1 = -1);
	~ToPortAudio();
	int init_pa();
	int start_pa();
	int stop_pa();
	int close_pa();
	int GetPhase() const;
private:
	void Work();
	static int PortAudioCallback(
		const void *inputBuffer, void *outputBuffer,
		unsigned long framesPerBuffer,
		const PaStreamCallbackTimeInfo* timeInfo,
		PaStreamCallbackFlags statusFlags,
		void *userData );
	float* buffer_a;
	float* buffer_b;
	unsigned int frames_per_buffer;
	int phase;
	bool initialized_portaudio;
	bool playing;
	bool state_changed;
	PaState state1;
	PaStreamParameters outputParameters;
	PaStream* stream;
};
#endif

