//-----------------------------------------------------------
//    vca.cpp
//-----------------------------------------------------------
#include "vca.h"
#include "eg.h"
#include <math.h>
//-----------------------------------------------------------
//    
//-----------------------------------------------------------

//-----------------------------------------------------------
//    
//-----------------------------------------------------------
SynthVCA::SynthVCA(int id1)
	: SignalProcessBase(id1)
{
	eg1 = new SynthEG();
	SetSignalProcessType(VCA);
}

//-----------------------------------------------------------
//    
//-----------------------------------------------------------
SynthVCA::~SynthVCA()
{
	delete eg1;
}

//-----------------------------------------------------------
//    
//-----------------------------------------------------------
void SynthVCA::Work()
{
	unsigned int bsz = GetSizeBuffer();
	int oncnt = GetNoteOnCount();
	int offcnt = GetNoteOffCount();
	float itmp[bsz];
	float otmp[bsz];
	float vol = 0.0;
	GetUpStream(0)->CopyBuffer(itmp);
	
	if(oncnt >= 0){
		for(int i1 = 0; i1 < bsz; i1++){
			if(i1 < oncnt){
				otmp[i1] = itmp[i1];
			}else if(i1 == oncnt){
				eg1->SetEGState(ATTACK);
				SetNoteOnCount(-1);
				vol = eg1->GetValue();
				otmp[i1] = itmp[i1] * vol;
			}else if(i1 > oncnt){
				if(i1==offcnt){
					eg1->SetEGState(RELEASE);
					SetNoteOffCount(-1);
				}
				vol = eg1->GetValue();
				otmp[i1] = itmp[i1] * vol;
			}
		}
		WriteBuffer(otmp);
	
	}else if((eg1->GetEGState()!=NON)){
		for(int i1 = 0; i1 < bsz; i1++){
			if(i1==offcnt){
				eg1->SetEGState(RELEASE);
				SetNoteOffCount(-1);
			}
			vol = eg1->GetValue();
			otmp[i1] = itmp[i1] * vol;
		}
		WriteBuffer(otmp);
	
	}else{
		InitializeBuffer();
	}
	
	GiveTask();
	AccomplishTask();
}
