//-----------------------------------------------------------
//    SynthVCF
//-----------------------------------------------------------
#ifndef __SYNTH_VCF_H__
#define __SYNTH_VCF_H__
#include "signal_process_base.h"
class SynthEG;
//-----------------------------------------------------------
//    class SynthVCF
//-----------------------------------------------------------
class SynthVCF : public SignalProcessBase
{
public:
	SynthVCF(int id1 = -1);
	~SynthVCF();
	void SetCutOffFrequency(const float frequency);
private:
	void Work();
	float cutoff;
	float bi[4];
	float ai[5];
	static const float min_freq;
	static const float max_freq;
	static const float delta_freq;
	static const unsigned int bw_table_size;
	static float **butterworth4_ai;
	static float **butterworth4_bi;
	void SetTable();
	void SetButterworthConstants(const float frequency);
	void CalcButterWorthConstants(float frequency, float a[5], float b[4]);
	bool ExistOtherVCF() const;
	SynthEG *eg1;
};

#endif

