//-----------------------------------------------------------
//    SynthVCO
//-----------------------------------------------------------
#ifndef __SYNTH_VCO_H__
#define __SYNTH_VCO_H__
#include "signal_process_base.h"
//-----------------------------------------------------------
//    enum WaveType
//-----------------------------------------------------------
enum WaveType{SIN, TRI, SAW};
class SynthEG;
//-----------------------------------------------------------
//    class SynthVCO
//-----------------------------------------------------------
class SynthVCO : public SignalProcessBase
{
public:
	SynthVCO(int id1 = -1);
	~SynthVCO();
	void SetFrequency(float f1);
	void SetWaveType(WaveType wt1){wtype = wt1;}
	void SetWaveTable();
private:
	bool ExistOtherVCO() const;
	void Work();
	static const unsigned int size_table;
	float frequency;
	static float* sin_wave;
	static float* tri_wave;
	static float* saw_wave;
	float phase_position;
	float delta;
	SynthEG *eg1;
	WaveType wtype;
};

#endif

